/**
 * \file circle.cpp
 * \brief Circle osztály tagfüggvényeinek megvalósítása
 */
#include "circle.h"
#include "memtrace.h"

/// Kört rajzoló fv.
void Circle::draw() const {
    if (fill) {
        filledCircleColor(renderer, p0.x, p0.y, r, fg);
        circleColor(renderer, p0.x, p0.y, r, fg);
    } else {
        filledCircleColor (renderer, p0.x, p0.y, r, bg);
        circleColor (renderer, p0.x, p0.y, r, fg);
    }
}

// Körlap egy pontját tesztelő fv.
bool Circle::contains(const Point& p) {
    return r >= p0.distance(p);  // sugáron belül esik
}

/// esemény
bool Circle::eventHandler(const SDL_Event& ev) {
    if (ev.type == SDL_MOUSEBUTTONDOWN) {   // kitöltés változik
        if (ev.button.button == SDL_BUTTON_LEFT) {
            fill = !fill;
            draw();
        }
        return true;
    } else if (ev.type == SDL_MOUSEMOTION && ev.motion.state != 0) { // drag
        move(Point(ev.motion.xrel, ev.motion.yrel));
        return true;
    }
    return false;
}
