/**
 * \file Circle.h
 * \brief Circle osztály deklarációja
 */
#ifndef CIRCLE_H
#define CIRCLE_H

#include "widget.h"

/// Kör osztály.
/// Eseménykezelője kezeli a gombnyomást, ami a kitöltést váltja.
/// Kezeli továbbá a húzást (drag). Ekkor meghívja a Widget move tagfüggvényét.
class Circle : public Widget {
    int r;      ///< sugár
    bool fill;  ///< kitöltött-e a kör
public:
    /// Konstruktor
    /// @param p0 - kezdőpont
    /// @param r -  sugár
    /// @param sz - szín és átlátszóság
    Circle(const Point& p0, int r,
           const Color& fg = WHITE, const Color& bg = BLACK, bool  fill = false)
                    :Widget(p0, fg, bg), r(r), fill(fill)  // ősosztály + adattagok inic
                    {}

    /// kört rajzol
    void draw() const;

    /// belül van-e
    bool contains(const Point& p);

    /// esemény
    bool eventHandler(const SDL_Event& ev);

    ~Circle() {
        fg = bg;        // rajzolási szín legyen a háttér színe
        draw(); 		// letörlés
    }
};

#endif // CIRCLE_H
