/**
 *  \file color.h
 *  \brief Color osztály deklarációja
 */
#ifndef COLOR_H
#define COLOR_H

/// Az egyszerűség kedvéért minden tagja publikus.
/// Így nem kell getter/setter.
struct Color {
    Uint8 r, g, b;    ///< RGB
    Uint8 a;          ///< átlátszóság

    /// @param r - red
    /// @param g - green
    /// @param b - blue
    /// @param a - transparency
    Color(Uint8 r = 0, Uint8 g = 0, Uint8 b = 0, Uint8 a = 255)
                        :r(r), g(g), b(b), a(a) {}

    /// cast Uint32-re
    operator Uint32() const { return (r << 24) + (g << 16) + (b << 8) + a; }
};

/// Színkontsansok
const Color BLACK(0,0,0);
const Color WHITE(255,255,255);
const Color RED(255,0,0);
const Color GREEN(0,255,0);
const Color BLUE(0,0,255);
const Color BACKGND = BLACK;

#endif // COLOR_H

