/**
 * \file container.cpp
 * \brief Container osztály függvényeinek megvalósítása
 */

#include "container.h"
#include "memtrace.h"


// Új widgetet ad a tárolóhoz
void Container::add(Widget *w) {
    widgets.push_back(w);
    w->draw();
}

// Törli a tárolót
void Container::clear() {
    for (size_t i = 0; i < widgets.size(); i++)
        delete widgets[i];
    widgets.clear();
}

// Tárolóban levő minden elemre meghívja a rajzolót
void Container::draw() const {
    for (size_t i = 0; i < widgets.size(); i++)
        widgets[i]->draw();
}

// Eseménykezelés
bool Container::eventHandler(const SDL_Event& ev) {
    for (size_t i = widgets.size()-1; i >= 0 && i < widgets.size(); i--) { // a méret megváltozhat a ciklusban !
        if (widgets[i]->contains(cursor)) {             // ha a területére esik
            if (widgets[i]->eventHandler(ev))           // akkor elküldi az eseményt
                return true;
        }
    }
    return false;
}
