/**
 *  \file point.h
 *  \brief Point osztály deklarációja
 */
#ifndef POINT_H
#define POINT_H
#include <cmath>

/// Az egyszerűség kedvéért minden tagja publikus.
/// Igy nem kell getter/setter.
/// Csak azok az operatorok lettek megvalósítva, melyeket használ a demo
struct Point {
    int x;
    int y;
    Point(int x = 0, int y = 0) :x(x), y(y) {}

    /// += operator
    Point& operator+=(const Point& rhs_p) {
        x += rhs_p.x;
        y += rhs_p.y;
        return *this;
    }

    /// - operator
    Point operator-(const Point& rhs_p) const {
        return Point(rhs_p.x-x, rhs_p.y-y);
    }

    /// távolság
    double distance(Point p2) const {
        p2 = *this - p2;
        return sqrt(p2.x*p2.x+p2.y*p2.y);
    }
};

#endif // POINT_H
